<template>
    <section clob-diff ref="clob-diff"></section>
</template>

<script lang="ts">
import { Component, Vue, Watch, Prop } from 'vue-property-decorator';
import { createPatch } from 'diff';
import { DiffRow } from '../../lib/diffData';
import { Diff2HtmlUI } from 'diff2html/lib/ui/js/diff2html-ui';

import 'diff2html/bundles/css/diff2html.min.css';

@Component({})
export default class extends Vue {
  @Prop()
  private diffRow!: DiffRow;

  private diffUI!: Diff2HtmlUI;

  public mounted() {
    const target = this.$refs['clob-diff'] as HTMLElement;
    const diff = createPatch(this.diffRow.columnName, this.diffRow.oldVal || '', this.diffRow.newVal || '');

    this.diffUI = new Diff2HtmlUI(target, diff, {
      drawFileList: false,
      outputFormat: 'side-by-side',
      highlight: false,
    });
    this.diffUI.draw();

    const fileWrapper = target.querySelector('[data-lang]') as HTMLElement;
    if (this.diffRow.oldVal[0] === '<') {
      fileWrapper.setAttribute('data-lang', 'xml');
    } else if (this.diffRow.oldVal[0] === '{') {
      fileWrapper.setAttribute('data-lang', 'json');
    }
    this.diffUI.highlightCode();
  }
}
</script>

<style lang="scss" scoped>
[clob-diff] {
  width: 0; // otherwise diff2html element takes 100vw space
  position: relative;
}
</style>